angular.module('openITCOCKPIT')
    .controller('UsersIndexController', function($scope, $http, SortService, MassChangeService){

        $scope.currentPage = 1;
        $scope.useScroll = false;
        $scope.deleteUrl = '/users/delete/';
        $scope.massChange = {};

        SortService.setSort('Users.username');
        SortService.setDirection('asc');

        /** Filter Settings **/
        var defaultFilter = function(){
            $scope.current_state = [];
            $scope.filter_username = '';
            $scope.filter_firstname = '';
            $scope.filter_lastname = '';
            $scope.showFilter = false;
        };

        defaultFilter();
        /** Filter Settings **/

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
        };

        $scope.init = true;
        $scope.load = function(){
            $http.get("/Users/index.json", {
                params: {
                    'scroll': $scope.useScroll,
                    'sort': SortService.getSort(),
                    'page': $scope.currentPage,
                    'direction': SortService.getDirection(),
                    'filter[Users.username]': $scope.filter_username,
                    'filter[Users.firstname]': $scope.filter_firstname,
                    'filter[Users.lastname]': $scope.filter_lastname
                }
            }).then(function(result){
                $scope.users = result.data.users;
                $scope.myUserId = result.data.myUserId;
                $scope.scroll = result.data.scroll;
                $scope.paging = result.data.paging;
                $scope.init = false;
            });
        };

        $scope.getObjectForDelete = function(user){
            var object = {};
            object[user.id] = user.username;
            return object;
        };

        $scope.getObjectsForDelete = function(){
            var objects = {};
            var selectedObjects = MassChangeService.getSelected();
            for(var key in $scope.users){
                for(var id in selectedObjects){
                    if(id == $scope.users[key].id){
                        objects[id] = $scope.users[key].username;
                    }
                }
            }
            return objects;
        };

        $scope.selectAll = function(){
            if($scope.users){
                for(var key in $scope.users){
                    var id = $scope.users[key].id;
                    if(id !== $scope.myUserId){
                        $scope.massChange[id] = true;
                    }
                }
            }
        };

        $scope.undoSelection = function(){
            MassChangeService.clearSelection();
            $scope.massChange = MassChangeService.getSelected();
            $scope.selectedElements = MassChangeService.getCount();
        };

        //Fire on pageload
        $scope.$watchGroup(['filter_username', 'filter_firstname', 'filter_lastname'], function(){
            if($scope.init){
                return;
            }
            $scope.load();
        });

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        SortService.setCallback($scope.load);
        SortService.triggerReload();

        $scope.$watch('massChange', function(){
            MassChangeService.setSelected($scope.massChange);
            $scope.selectedElements = MassChangeService.getCount();
        }, true);

    });
